#include "Osoba.h"

Osoba::Osoba(const char* i, const char* n)
{
	imie = new char[strlen(i)+1];
	nazwisko = new char[strlen(n)+1];
	strcpy(imie, i);
	strcpy(nazwisko, n);
	cout << "Konstruktor zwykly Osoby -> " << imie << ' ' << nazwisko << endl;
}


Osoba::~Osoba()
{
	cout << "Destruktor Osoby -> ";
	if (imie && nazwisko) cout << imie << ' ' << nazwisko << endl;
	else cout << "nullptr\n";

	delete[] imie;
	delete[] nazwisko;
	imie = nullptr;
	nazwisko = nullptr;
}


void Osoba::Wypisz() const
{
	cout << imie << ' ' << nazwisko << endl;
}


void Osoba::ZmienImie(const char* nowe)
{
	delete[]imie;
	imie = new char[strlen(nowe) + 1];
	strcpy(imie, nowe);
}

void Osoba::ZmienNazwisko(const char* nowe)
{
	delete[]nazwisko;
	nazwisko = new char[strlen(nowe) + 1];
	strcpy(nazwisko, nowe);
}

Osoba::Osoba(const Osoba& wzor)
{
	imie = new char[strlen(wzor.imie)+1];
	nazwisko = new char[strlen(wzor.nazwisko)+1];

	strcpy(imie,wzor.imie);
	strcpy(nazwisko,wzor.nazwisko);
	cout << "Konstruktor Kopiujacy Osoby -> " << imie << ' ' << nazwisko << endl;
}


Osoba& Osoba::operator=(const Osoba& wzor)
{
	cout << "Operator= Osoby\n";
	if (this != &wzor)
	{
		// cz destruktorowa
		delete[] imie;
		delete[] nazwisko;
		//cz konstruktora kopujcego
		imie = new char[strlen(wzor.imie) + 1];
		nazwisko = new char[strlen(wzor.nazwisko) + 1];

		strcpy(imie, wzor.imie);
		strcpy(nazwisko, wzor.nazwisko);
	}
	return *this;
}

Osoba::Osoba(Osoba&& wzor)noexcept :imie{wzor.imie},nazwisko(wzor.nazwisko)
{
	wzor.imie = nullptr;
	wzor.nazwisko = nullptr;
	cout << "Konstruktor przenoszacy Osoby\n";
}

Osoba& Osoba::operator=(Osoba&& wzor)noexcept
{
	cout << "Operator= przenoszacy Osoby\n";
	if (&wzor != this)
	{
		delete[]imie;
		delete[]nazwisko;

		imie = wzor.imie;
		nazwisko = wzor.nazwisko;
		wzor.imie = nullptr;
		wzor.nazwisko = nullptr;
	}
	return *this;
}
